<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Login Form</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
        crossorigin="anonymous"></script>
</head>

<body>
    <h1>Login Form</h1>
    <div class="container">
        <form id="login-form">
            <div class="form-group">
                <label for="exampleInputEmail1">Email address</label>
                <input type="email" class="form-control" id="input-username" aria-describedby="emailHelp">
                <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                    else.</small>
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Password</label>
                <input type="password" class="form-control" id="input-password">
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>
</body>
<script>
    'use strict';

    // Nhanh moi
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";

    var loginForm = document.getElementById("login-form");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    loginForm.addEventListener("submit", (e) => {
        // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
        e.preventDefault();

        var username = document.getElementById("input-username");
        var password = document.getElementById("input-password");

        var vUser = {
            userName: "",
            password: ""
        }
        vUser.userName = username.value;
        vUser.password = password.value;

        // kiem tra du lieu 
        if (kiemTraDuLieu(vUser)) {
            // Tiếp theo thực hiện 4 bước để gọi api login
            onLogin(vUser);
        }
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    function onLogin(paramUserLogin) {
        const vParams = new URLSearchParams({
            email: paramUserLogin.userName,
            password: paramUserLogin.password
        });
        // create a request
        var vXmlHttpLogin = new XMLHttpRequest();
        vXmlHttpLogin.open("GET", gBASE_URL + "?" + vParams.toString(), true);
        vXmlHttpLogin.send();
        vXmlHttpLogin.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginInfo = vXmlHttpLogin.responseText;
                    console.log(vLoginInfo);
                }
            }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    function kiemTraDuLieu(paramUser) {
        if (paramUser.userName.length < 5) {
            alert("ten dang nhap phai co do dai > 5");
            return false;
        }

        if (paramUser.password.length < 8) {
            alert("Mat khau phai co it nhat 8 ky tu");
            return false;
        }
        return true;
    }


</script>

</html>